local MAXKILLCOOLDOWN = 10

freeslot("SPR_HAND", "S_HANDFRONT", "S_HANDBACK", "S_REPORT", "MT_HAND", "S_PLAY_SWOOSH", "S_NOTE1", "S_NOTE2", "SPR_NOTE")

mobjinfo[MT_HAND] = {
	doomednum = -1,
	spawnstate = S_HANDFRONT,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

states[S_HANDFRONT] = {
	sprite = SPR_HAND,
	frame = A|FF_FULLBRIGHT|FF_TRANSMASK,
	tics = 35,
	nextstate = S_NULL
}

states[S_NOTE1] = {
	sprite = SPR_NOTE,
	frame = A|FF_FULLBRIGHT,
	tics = 50,
	nextstate = S_NULL
}

states[S_NOTE2] = {
	sprite = SPR_NOTE,
	frame = B|FF_FULLBRIGHT,
	tics = 50,
	nextstate = S_NULL
}

states[S_HANDBACK] = {
	sprite = SPR_HAND,
	frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE,
	tics = 35,
	nextstate = S_HANDBACK
}

states[S_PLAY_SWOOSH] = {
	sprite = SPR_PLAYER,
	frame = SPR2_SHOS,
	tics = 3,
	nextstate = S_PLAY_STND
}

states[S_REPORT] = {
	sprite = SPR_HAND,
	frame = C|FF_FULLBRIGHT|FF_PAPERSPRITE,
	tics = 35,
	nextstate = S_REPORT
}

for i = 1, 5  //Dance Script starts here
freeslot("S_PLAY_DRIPPIN", "SPR2_VENT", "S_PLAY_VENT","S_PLAY_AMOGUS", "S_PLAY_FNF", "S_PLAY_FNF2", "SPR2_DRIP", "SPR2_AMOG", "SPR2_FNF2", "SPR2_FNF_", "sfx_msus"..i)
end

states[S_PLAY_DRIPPIN] = {SPR_PLAY, SPR2_DRIP, 2, nil, 0, 0, S_PLAY_DRIPPIN}
states[S_PLAY_AMOGUS] = {SPR_PLAY, SPR2_AMOG, 2, nil, 0, 0, S_PLAY_AMOGUS}
states[S_PLAY_FNF] = {SPR_PLAY, SPR2_FNF_, 3, nil, 0, 0, S_PLAY_FNF}
states[S_PLAY_FNF2] = {SPR_PLAY, SPR2_FNF2, 3, nil, 0, 0, S_PLAY_FNF2}
states[S_PLAY_VENT] = {SPR_PLAY, SPR2_VENT, 3, nil, 0, 0, S_PLAY_VENT}

local susmusic = {   //Music
sfx_msus1, sfx_msus2,
sfx_msus3, sfx_msus4,
sfx_msus5}

local dances = {	//States
S_PLAY_AMOGUS, S_PLAY_FNF,
S_PLAY_FNF, S_PLAY_FNF,
S_PLAY_FNF2, S_PLAY_DRIPPIN}

addHook("PlayerThink", function(player)	//The hook itself for "Dance" and Streching Bounce
	if player.dancin == nil
		player.dancin = false
	end	
	if player.dance == nil
		player.dance = false
	end
	if player.dancer == nil
		player.dancer = false
	end
	if player.dance2 == nil
		player.dance2 = false
	end
	if player.dance3 == nil
		player.dance3 = 0
	end
	local sus = P_RandomRange(1, 5)
	if (player.mo.skin == "impostor")
	and player.cmd.buttons & BT_TOSSFLAG
	and P_IsObjectOnGround(player.mo)
	and player.toosflag == false
		if player.dancin == false
			player.dancin = true
			S_StartSound(player.mo, susmusic[sus], player)
			S_FadeMusic(0, 1*MUSICRATE, player)
			player.dance = true
		elseif player.dancin == true
			S_FadeMusic(100, 1*MUSICRATE, player)
			if S_SoundPlaying(player.mo, sfx_msus1)
				S_StopSoundByID(player.mo, sfx_msus1)
			elseif S_SoundPlaying(player.mo, sfx_msus2)
				S_StopSoundByID(player.mo, sfx_msus2)
			elseif S_SoundPlaying(player.mo, sfx_msus3)
				S_StopSoundByID(player.mo, sfx_msus3)
			elseif S_SoundPlaying(player.mo, sfx_msus4)
				S_StopSoundByID(player.mo, sfx_msus4)
			elseif S_SoundPlaying(player.mo, sfx_msus5)
				S_StopSoundByID(player.mo, sfx_msus5)
			end
			COM_BufInsertText(player, "tunes -default")
			player.dancin = false
			player.rollingtackler = false
			player.pflags = $1 & ~PF_STASIS
			player.mo.state = S_PLAY_STND
			player.dancer = true
		end	
	end
	
	local notes = {
	S_NOTE1, S_NOTE2}
	local randomrate = P_RandomRange(3, 15)
	local colors = {
	SKINCOLOR_RED,SKINCOLOR_ORANGE,SKINCOLOR_YELLOW,SKINCOLOR_GREEN,SKINCOLOR_CYAN,SKINCOLOR_BLUE,SKINCOLOR_PURPLE}
	local randomnote = P_RandomRange(1,2)
	local color = P_RandomRange(1,7)
	if player.dancin
		if (leveltime%randomrate) == 1
		local note = P_SpawnMobj(P_RandomRange(player.mo.x/FRACUNIT, player.mo.x/FRACUNIT+player.mo.radius/FRACUNIT)*FRACUNIT, P_RandomRange(player.mo.y/FRACUNIT, player.mo.y/FRACUNIT+player.mo.radius/FRACUNIT)*FRACUNIT, P_RandomRange(player.mo.z/FRACUNIT+player.mo.height/FRACUNIT-5, player.mo.z/FRACUNIT+player.mo.height/FRACUNIT)*FRACUNIT, MT_THOK)
		note.fuse = 15
		note.state = notes[randomnote]
		note.color = colors[color]
		note.momz = P_RandomRange(2, 5)*FRACUNIT
		end
		if S_SoundPlaying(player.mo, sfx_msus5)
			if (player.mo.state ~= S_PLAY_DRIPPIN)
				player.mo.state = S_PLAY_DRIPPIN
			end
			player.dance = true
		end
		if S_SoundPlaying(player.mo, sfx_msus2) or  S_SoundPlaying(player.mo, sfx_msus3)
			if (player.mo.state ~= S_PLAY_FNF)
				player.mo.state = S_PLAY_FNF
			end
			player.dance = false
		end
		if S_SoundPlaying(player.mo, sfx_msus4)
			if (player.mo.state ~= S_PLAY_FNF2)
				player.mo.state = S_PLAY_FNF2
			end
			player.dance = false
		end
		if S_SoundPlaying(player.mo, sfx_msus1)
			if (player.mo.state ~= S_PLAY_AMOGUS)
				player.mo.state = S_PLAY_AMOGUS
			end
			player.dance = true
		end
		if not (S_SoundPlaying(player.mo, sfx_msus1) or S_SoundPlaying(player.mo, sfx_msus2) or S_SoundPlaying(player.mo, sfx_msus3) or S_SoundPlaying(player.mo, sfx_msus4) or S_SoundPlaying(player.mo, sfx_msus5))
			S_StartSound(player.mo, susmusic[sus], player)		
		end
		player.pflags = $|PF_STASIS
	end	
	if player.dance == false
		if (player.mo.state == S_PLAY_FNF or player.mo.state == S_PLAY_FNF2)
			player.mo.spriteyscale = 3*FRACUNIT - FRACUNIT/5
			player.mo.spritexscale = 3*FRACUNIT - FRACUNIT/5
		else
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
		end
	end	
	if (player.mo.state == S_PLAY_DRIPPIN or player.mo.state == S_PLAY_FNF or player.mo.state == S_PLAY_AMOGUS)
		player.pflags = $|PF_STASIS
		if S_SoundPlaying(player.mo, sfx_msus5)
			if (player.mo.state ~= S_PLAY_DRIPPIN)
				player.mo.state = S_PLAY_DRIPPIN
			end
			player.dance = true
		end
		if S_SoundPlaying(player.mo, sfx_msus2) or  S_SoundPlaying(player.mo, sfx_msus3)
			if (player.mo.state ~= S_PLAY_FNF)
				player.mo.state = S_PLAY_FNF
			end
			player.dance = false
		end
		if S_SoundPlaying(player.mo, sfx_msus4)
			if (player.mo.state ~= S_PLAY_FNF2)
				player.mo.state = S_PLAY_FNF2
			end
			player.dance = false
		end
		if S_SoundPlaying(player.mo, sfx_msus1)
			if (player.mo.state ~= S_PLAY_AMOGUS)
				player.mo.state = S_PLAY_AMOGUS
			end
			player.dance = true
		end
		if not (S_SoundPlaying(player.mo, sfx_msus1) or S_SoundPlaying(player.mo, sfx_msus2) or S_SoundPlaying(player.mo, sfx_msus3) or S_SoundPlaying(player.mo, sfx_msus4) or S_SoundPlaying(player.mo, sfx_msus5))
			S_StartSound(player.mo, susmusic[sus], player)		
		end
	end	
	if (player.cmd.buttons & BT_JUMP)
	and (player.mo.state == S_PLAY_DRIPPIN or player.mo.state == S_PLAY_FNF or player.mo.state == S_PLAY_AMOGUS)
	and player.dancin == true
		if S_SoundPlaying(player.mo, sfx_msus1)
			S_StopSoundByID(player.mo, sfx_msus1)
		elseif S_SoundPlaying(player.mo, sfx_msus2)
			S_StopSoundByID(player.mo, sfx_msus2)
		elseif S_SoundPlaying(player.mo, sfx_msus3)
			S_StopSoundByID(player.mo, sfx_msus3)
		elseif S_SoundPlaying(player.mo, sfx_msus4)
			S_StopSoundByID(player.mo, sfx_msus4)
		elseif S_SoundPlaying(player.mo, sfx_msus5)
			S_StopSoundByID(player.mo, sfx_msus5)
		end
		S_FadeMusic(100, 1*MUSICRATE, player)
		COM_BufInsertText(player, "tunes -default")
		player.dancin = false
		player.rollingtackler = false
		player.pflags = $1 & ~PF_STASIS
		player.mo.state = S_PLAY_JUMP
		player.dancer = true
	end
	if player.cmd.buttons & BT_TOSSFLAG
		player.toosflag = true
	else
		player.toosflag = false
	end
	player.dance3 = $1 + 15
	if player.dance == true
		player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
		player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
	end	
	if player.dancer == true
			if player.mo.spriteyscale != FRACUNIT and player.mo.spritexscale < FRACUNIT
				player.mo.spriteyscale = FRACUNIT + FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
			end
			if player.mo.spriteyscale != FRACUNIT and player.mo.spritexscale > FRACUNIT
				player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
			end	
			if player.mo.spritexscale != FRACUNIT and player.mo.spritexscale < FRACUNIT
				player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
			end
			if player.mo.spritexscale != FRACUNIT and player.mo.spritexscale > FRACUNIT
				player.mo.spritexscale = FRACUNIT - FixedMul(sin(player.dance3*ANG1), FRACUNIT/10)
			end
			if player.mo.spriteyscale == FRACUNIT and player.mo.spritexscale == FRACUNIT
				player.dancer = false
			end	
		player.dance2 = false
		player.dance = false
	end
end)


/*local function LookForEnemies(p)  //Old P_LookForEnemis
	local lastmo
	local dist
	local lastdist = 0

	for mo in mobjs.iterate()
		if mo == p.mo // 'Ignore us' check
			continue
		end
		
		if (mo.health <= 0) // I'm Dead.
			continue
		end
		
		// Ignore anything EXCEPT Crawlas
		if not ((mo.flags & MF_ENEMY)
		or (mo.flags & MF_BOSS) or (mo.flags & MF_MONITOR)
		or (mo.type == MT_PLAYER)
		)
			continue
		end

		// Can't get it if you can't see it!
		if not P_CheckSight(p.mo,mo)
			continue
		end

		dist = P_AproxDistance(P_AproxDistance(p.mo.x - mo.x, p.mo.y - mo.y), p.mo.z - mo.z)
		if (lastmo and (dist > lastdist)) // Last one is closer to you?
			continue
		end
		
		local long = R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y)
		local longz = R_PointToDist(p.mo.z, mo.z)
		if long > 340*FRACUNIT
		and (longz > 300*FRACUNIT or longz < -300*FRACUNIT)
			continue
		end	

		// Found a target
		lastmo = mo
		lastdist = dist
	end
	return lastmo
end*/

local long

freeslot("sfx_kill", "sfx_report", "sfx_meet")

local function changecooldown(player, arg)  //Command
	if player.valid
	and multiplayer
		if arg == nil 
			CONS_Printf(player,'\n"impostor kill cooldown" is "'..(MAXKILLCOOLDOWN or 10)..'" default is "10"')
		else
			local value = tonumber(arg)
			if value >= 10 and value <= 120
				MAXKILLCOOLDOWN = value
			else
				CONS_Printf(player,"Invalid argument")
			end
		end
	else
		CONS_Printf(player,"You can only use it in Multiplayer!")
	end
end	

COM_AddCommand("killcooldown", changecooldown, COM_ADMIN)

local stabber
local killed 

freeslot("SKINCOLOR_OUTLINE") //Skin for red outline when something is targeted

skincolors[SKINCOLOR_OUTLINE] = {
    name = "Outline",
    ramp = {36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36},
    invcolor = SKINCOLOR_RED,
    invshade = 0,
    chatcolor = V_REDMAP,
    accessible = false
}

freeslot("sfx_vent", "S_VENT", "SPR_OVEN")

states[S_VENT] = {
	sprite = SPR_OVEN,
	frame = A|FF_FULLBRIGHT,
	tics = 50,
	nextstate = S_VENT
}

addHook("AbilitySpecial", function(player) //Fail Vent
	if player.mo.skin == "impostor" and player.playerstate == PST_LIVE and player.valid and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if not (player.pflags & PF_THOKKED)
		and player.crouch == false
			player.pflags = $|PF_THOKKED
			player.mo.state = S_PLAY_VENT
			P_SpawnParaloop(player.mo.x,player.mo.y,player.mo.z,player.mo.scale*64,12,MT_DUST,ANGLE_90,nil,true)
			P_SetObjectMomZ(player.mo, 10*FRACUNIT)
			S_StartSound(player.mo, sfx_adderr)
		end
	end
end)

addHook("ShouldDamage", function(mo) //Death 
	local player = mo.player
	if mo.skin == "impostor" and player.playerstate == PST_LIVE and mo.valid and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.rings <= 0
		and not (player.powers[pw_flashing] or player.powers[pw_invulnerability])
			player.playerstate = PST_DEAD
			mo.state = S_PLAY_DEAD
			mo.rollangle = ANGLE_90
			S_StartSound(mo, sfx_kill)
			return false
		end
	end
end)	

addHook("PlayerThink", function(player)
	if player.mo.skin == "impostor" and player.playerstate == PST_DEAD and player.valid and not (player.powers[pw_carry] == CR_NIGHTSMODE) //Death 2
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.momz = 1
		player.mo.flags = $|MF_NOGRAVITY
	end	
	if player.mo.skin == "impostor" and player.playerstate == PST_LIVE and player.valid and not (player.powers[pw_carry] == CR_NIGHTSMODE) //almost everything aka Venting, Crouching, Killing, reporting
		player.target = P_LookForEnemies(player, false, true)
		if player.target
			long = R_PointToDist2(player.mo.x, player.mo.y, player.target.x, player.target.y)
		end	
		if player.killcooldown == nil
			player.killcooldown = MAXKILLCOOLDOWN
		end
		if player.target and long < 500*FRACUNIT
			//P_SpawnLockOn(player, player.target, S_LOCKON1)
			if player ~= displayplayer return end
			local ghost = P_SpawnGhostMobj(player.target)
			ghost.scale = player.target.scale + FRACUNIT/5
			ghost.spriteyoffset = $1 - 5*FRACUNIT
			ghost.frame = $ & ~(FF_TRANSMASK|FF_TRANS50)
			local gotox = player.target.x+FixedMul(5*FRACUNIT, cos(consoleplayer.mo.angle))
			local gotoy = player.target.y+FixedMul(5*FRACUNIT, sin(consoleplayer.mo.angle))
			local gotoz = player.target.z+FixedMul(5*FRACUNIT, cos(consoleplayer.mo.angle))
			P_TeleportMove(ghost, gotox, gotoy, gotoz)
			ghost.colorized = true
			ghost.fuse = 5
			ghost.momx = player.target.momx
			ghost.momy = player.target.momy
			ghost.momz = player.target.momz
			ghost.color = SKINCOLOR_OUTLINE
		end	
		/*if player.cmd.buttons & BT_CUSTOM3
			if player.c3 == false
				if player.change == "y"
					player.change = "x"
				elseif player.change == "x"
					player.change = "y"
				end
			end
			player.c3 = true
		else
			player.c3 = false
		end*/
		/*print(player.height)
		if player.cmd.buttons & BT_WEAPONNEXT
			player.height = $1 + 5*FRACUNIT
		end	
		if player.cmd.buttons & BT_WEAPONPREV
			player.height = $1 - 5*FRACUNIT
		end*/	
		if player.sabotage2 == nil
			player.sabotage2 = 0
		end
		if player.sabotage2 > 0
			player.sabotage2 = $1 - 1
		end
		if player.sabotage2 <= 0
		and player.sabotage == true
			player.sabotage = false
			player.sabotage3 = 500
		end
		if player.sabotage3 == nil
			player.sabotage3 = 0
		end	
		if player.sabotage3 > 0
			player.sabotage3 = $1 - 1
		end
		if player.ventcooldown == nil
			player.ventcooldown = 0
		end	
		if player.ventcooldown2 == nil
			player.ventcooldown2 = 0
		end
		if player.ventcooldown2 > 0
			if not (player.powers[pw_sneakers])
				if (leveltime % 15) == 1
					player.ventcooldown2 = $1 - 1
				end
			else
				player.ventcooldown2 = $1 - 1
			end	
		end
		if player.vented == nil
			player.vented = false
		end
		if player.ventcooldown2 <= 0
			player.ventcooldown2 = 0
			player.ventcooldown = 0
		end	
		if player.vented == true
			player.mo.state = S_PLAY_VENT
			player.powers[pw_flashing] = 1
			if P_IsObjectOnGround(player.mo) 
				if player.mo.eflags & MFE_JUSTHITFLOOR
					local vent = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
					vent.flags2 = $|MF2_SPLAT
					vent.fuse = 50
					vent.angle = player.mo.angle
					vent.state = S_VENT
					vent.scale = FRACUNIT/7
				end	
				player.mo.flags2 = $|MF2_DONTDRAW
				player.normalspeed = 36*FRACUNIT
				player.pflags = $|PF_INVIS 
				player.jumpfactor = 0
				player.height = 5*FRACUNIT
					if player.powers[pw_sneakers]
						if (leveltime % 15) == 1
							player.ventcooldown = $1 + 5
						end
					else
						player.ventcooldown = $1 + 1
					end	
				if player.ventcooldown >= 50 or (player.cmd.buttons & BT_JUMP or player.cmd.buttons & BT_SPIN or player.cmd.buttons & BT_CUSTOM1 or player.cmd.buttons & BT_CUSTOM3 or player.cmd.buttons & BT_TOSSFLAG)
				
					player.ventcooldown2 = 20
					player.ventcooldown = 0
					player.vented = false
					player.powers[pw_flashing] = 5
					P_SetObjectMomZ(player.mo, 7*FRACUNIT)
					player.mo.state = S_PLAY_VENT
					S_StartSound(player.mo, sfx_vent)
					player.mo.flags2 = $ & ~MF2_DONTDRAW
					player.pflags = $ & ~PF_INVIS 
					local vent = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
					vent.flags2 = $|MF2_SPLAT
					vent.fuse = 50
					vent.angle = player.mo.angle
					vent.state = S_VENT
					vent.scale = FRACUNIT/7
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.height = skins[player.mo.skin].height
				end
			else
				player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
				player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
			end	
		end	
		if player.cmd.buttons & BT_CUSTOM1
		and player.dancin == false
			if P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_GLIDE_LANDING
			else
				player.mo.state = S_PLAY_VENT
			end	
			player.height = skins[player.mo.skin].spinheight
			player.crouch = true
			player.pflags = $|PF_STASIS
			if player.cmd.buttons & BT_CUSTOM3
			and player.custom3 == false
				player.sabotage = true
				player.sabotage2 = 500
			end	
			if player.pflags & PF_JUMPED
			and player.cmd.buttons & BT_JUMP
			and player.jump == false
			and player.ventcooldown2 <= 0
			and player.ventcooldown <= 0
			and player.vented == false
				if player.mo.state != S_PLAY_VENT
					player.mo.state = S_PLAY_VENT
				else
					player.mo.state = S_PLAY_VENT
					P_SpawnGhostMobj(player.mo)
				end	
				P_SetObjectMomZ(player.mo, 7*FRACUNIT)
				player.vented = true
				player.ventcooldown2 = 20
				if player.ventcooldown > 0
					player.ventcooldown = 0
				end	
				S_StartSound(player.mo, sfx_vent)
			end	
		end
		if player.cmd.buttons & BT_JUMP
			player.jump = true
		else
			player.jump = false
		end	
		if player.crouch == nil
			player.crouch = false
		end
		if not (player.cmd.buttons & BT_CUSTOM1)
		and player.crouch == true
			player.pflags = $|PF_STASIS
			if P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_STND
			else
				player.mo.state = S_PLAY_FALL
			end	
			player.height = skins[player.mo.skin].height
			player.crouch = false
		end
		if player.killcooldown <= 0
			if player.cmd.buttons & BT_SPIN
			and player.spin == false
			and player.target and long < 500*FRACUNIT
			and player.dancin == false
				player.powers[pw_flashing] = 1
				P_TeleportMove(player.mo, player.target.x, player.target.y, player.target.z)
				P_DamageMobj(player.target, player.mo, player.mo, DMG_INSTAKILL)
				S_StartSound(player.mo, sfx_kill)
				player.mo.state = S_PLAY_SWOOSH
				player.mo.momz = 0
				player.killcooldown = MAXKILLCOOLDOWN
				player.pflags = $|PF_FULLSTASIS
				stabber = player.mo
				killed = 5
				if P_IsObjectOnGround(player.target)
					if player.pflags & PF_JUMPED
						player.pflags = $ & ~PF_JUMPED
					end
				else
					if not (player.pflags & PF_JUMPED)
						player.pflags = $|PF_JUMPED
					end
				end
			end
		end
		if player.reportcooldown == nil
			player.reportcooldown = 0
		end
		if player.reportcooldown > 0
			if not (player.powers[pw_sneakers])
				if (leveltime % 15) == 1
					player.reportcooldown = $1 - 1
				end
			else
				player.reportcooldown = $1 - 1
			end	
		end
		if player.cmd.buttons & BT_CUSTOM3
			if player.custom3 == false
			and player.target and not S_IdPlaying(sfx_report)
			and long < 500*FRACUNIT and player.dancin == false
			and player.crouch == false
			and player.reportcooldown <= 0
				//S_StartSound(player.mo, sfx_report)
				S_StartSoundAtVolume(player.target, sfx_report, 225)
				player.target.eject = true
				player.target.eject2 = 100
				stabber = player.mo
				player.reportcooldown = 40
			end
		end		
		if player.cmd.buttons & BT_CUSTOM3
			player.custom3 = true
		else
			player.custom3 = false
		end	
		if player.xkill == nil
			player.xkill = 237+10
		end	
		if player.killcooldown < 10
			player.xkill = 237+10
		end
		if player.killcooldown >= 10
			player.xkill = 241+10
		end	
		if player.killcooldown >= 100
			player.xkill = 245+10
		end
		if player.xreport == nil
			player.xreport = (237+10)+40
		end	
		if player.reportcooldown < 10
			player.xreport = (237+10)+40
		end
		if player.reportcooldown >= 10
			player.xreport = (241+10)+40
		end	
		if player.reportcooldown >= 100
			player.xreport = (245+10)+40
		end
		if player.vented == false
			if not (player.powers[pw_sneakers])
				player.normalspeed = skins[player.mo.skin].normalspeed
			else
				player.normalspeed = skins[player.mo.skin].normalspeed/2
			end
		end	
		if player.killcooldown > 0
			if not (player.powers[pw_sneakers])
				if (leveltime % 15) == 1
					player.killcooldown = $1 - 1
				end
			else
				player.killcooldown = $1 - 1
			end	
		end	
		if player.cmd.buttons & BT_SPIN
			player.spin = true
		else
			player.spin = false
		end	
	end
	/*local long2
	if player.mo.skin != "impostor" and player.valid and player.powers[pw_carry] != CR_NIGHTSMODE and player.playerstate == PST_LIVE and not stabber
		if stabber
			long2 = R_PointToDist2(player.mo.x, player.mo.y, stabber.x, stabber.y)
		end	
		if killed > 0
		and long2 < 500*FRACUNIT
			if player.cmd.buttons & BT_FIRENORMAL
				local exs = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height + 10*FRACUNIT, MT_THOK)
				exs.state = S_ALART1
				exs.fuse = 15
				S_StartSound(nil, sfx_alart, stabber.player)
			end
		end
	end*/				
end)

if killed == nil
	killed = 0
end

if killed > 0
	killed = $1 - 1
end	

local function KillButton(v, player) //Kill Button
	if player.mo and player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.skin == "impostor"
		local killbtn
		if player.target and long < 500*FRACUNIT
			killbtn = v.cachePatch("KILLBTN")
		end	
		if not (player.target) or player.killcooldown > 0 or (player.target and long >= 500*FRACUNIT)
			killbtn = v.cachePatch("NOKILLBTN")
		end	
		if killbtn
			v.drawScaled((233+10)*FRACUNIT, 179*FRACUNIT, FRACUNIT/10, killbtn, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
		end	
		if player.killcooldown
			if player.killcooldown > 0
				v.drawNum(player.xkill, 175-2, player.killcooldown, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
			end	
		end
	end
end
hud.add(KillButton)

local function VentButton(v, player) //Vent Buttons
	if player.mo and player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.skin == "impostor"
		local sabbtn
		
			if player.ventcooldown2 or player.vented == true
				sabbtn = v.cachePatch("NOVENT")
			else
				sabbtn = v.cachePatch("NOVENTREAL")
			end	
		
		if sabbtn
			v.drawScaled(283*FRACUNIT, 179*FRACUNIT, FRACUNIT/10, sabbtn, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
		end	
			if player.ventcooldown2
				if player.ventcooldown2 > 0
					v.drawNum(player.xreport, 184-10, player.ventcooldown2, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)	
				end
			end
			if player.ventcooldown
				if player.ventcooldown <= 20
					v.drawNum(player.xreport, 184-10, player.ventcooldown2, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)	
				end
			end
		
	end			
end
hud.add(VentButton)

local function ReportButton(v, player) //Report Buttons
	if player.mo and player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.skin == "impostor"
		local reportbtn
		/*if (player.target and long < 500*FRACUNIT) and player.reportcooldown <= 0
			reportbtn = v.cachePatch("REPORT")	
		else	
			reportbtn = v.cachePatch("NOREPORT")
		end*/
		if player.target and long < 500*FRACUNIT
			reportbtn = v.cachePatch("REPORT")
		end	
		if not (player.target) or player.reportcooldown > 0 or (player.target and long >= 500*FRACUNIT)
			reportbtn = v.cachePatch("NOREPORT")
		end
		if reportbtn
			v.drawScaled(283*FRACUNIT, 135*FRACUNIT, FRACUNIT/10, reportbtn, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
		end
		if player.reportcooldown
			if player.reportcooldown > 0
				v.drawNum(player.xreport, 130, player.reportcooldown, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS)
			end	
		end
	end
end
hud.add(ReportButton)

/*addHook("MobjThinker", function(mo)
	if (mo.flags & MF_ENEMY)
		if mo.noticed == nil
			mo.noticed = 0
		end	
		local long2 = R_PointToDist2(mo.x, mo.y, stabber.x, stabber.y)
		if mo.noticed <= 0
			if sabotage == false and killed > 0
				if long2 < 500*FRACUNIT
					P_DamageMobj(stabber, mo, mo)
					local exs = P_SpawnMobj(mo.x, mo.y, mo.z + 10*FRACUNIT, MT_THOK)
					exs.state = S_ALART1
					exs.fuse = 15
					S_StartSound(nil, sfx_alart, stabber.player)
					mo.noticed = 100
				end
			else
				if long2 < 200*FRACUNIT
					P_DamageMobj(stabber, mo, mo)
					local exs = P_SpawnMobj(mo.x, mo.y, mo.z + 10*FRACUNIT, MT_THOK)
					exs.state = S_ALART1
					S_StartSound(nil, sfx_alart, stabber.player)
					mo.noticed = 100
					exs.fuse = 15
				end
			end
		end	
		if mo.noticed > 0
			mo.noticed = $1 - 1
		end	
	end
end)*/

addHook("MobjThinker", function(mo) //Enemy hook after "reporting" them
	if mo.eject == true
		P_SetObjectMomZ(mo, 1*FRACUNIT, true)
		mo.rollangle = $1 + 5*ANG1
		if mo.eject2 > 0
			mo.eject2 = $1 - 1
		end	
		mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
		if mo.eject2 <= 0
			mo.eject = false
			mo.eject2 = 0
			P_KillMobj(mo, stabber, stabber)
		end	
	end
end)